#ifndef IDE_VIA6421_H
#define IDE_VIA6421_H

#include <linux/config.h>
#include <linux/pci.h>
#include <linux/ide.h>

static unsigned int init_via6421_chipset(struct pci_dev *, const char *);
static void init_via6421_hwif(ide_hwif_t *);
static void init_via6421_dma(ide_hwif_t *, unsigned long);

static ide_pci_device_t via6421_chipset[] __devinitdata = {
	{	/* 12 */
		.vendor		= PCI_VENDOR_ID_VIA,
		.device		= PCI_DEVICE_ID_VIA_6421,
		.name		= "VIA_6421",
		.init_chipset	= init_via6421_chipset,
		.init_iops	= NULL,
		.init_hwif	= init_via6421_hwif,
		.init_dma	= init_via6421_dma,
		.channels	= 3,
		.autodma	= AUTODMA,
		.enablebits	= {{0x00,0x00,0x00},{0x00,0x00,0x00}},
		.bootable	= ON_BOARD,
		.extra		= 0,
	},{
		.vendor		= 0,
		.device		= 0,
		.channels	= 0,
		.bootable	= EOL,
	}
};

#endif

